import {
  select,
  forceSimulation,
  forceManyBody,
  forceCenter,
} from 'd3';


let data;

d3.json('data.json').then(dataset => {
  data = dataset
  setTimeout(drawForce(), 1)
})

function drawForce() {
  

  
const svg = select('#container');
const width = +svg.attr('width');
const height = +svg.attr('height');
const centerX = width / 2;
const centerY = height / 2;
  
  
let map = d3.group(data, d => d.Month)
let dataByMonth = Array.from(map, ([key, value]) => ({key, value}))
                     
  let keys = dataByMonth.map(d => d.key)
  const colorObj = {
    Fruit : '#a497b8',
    Vegetable: '#bbd0d1',
    Grain: '#ffffe0',
    Protein: '#ffbcaf',
    Other: '#cf3759',

};
  
        const histYAccessor = d => d.Month;
    const colorAccessor = d => d.Type;

    const histXScale = d3.scaleBand()
        .domain(keys)
        .range([0, width])
        .padding(0.1);
  
//   const simulation = forceSimulation(data)
//  .force('charge', d3.forceManyBody().strength(5))
//   // .force('x', d3.forceX().strength(0.2).x(d => histXScale(histYAccessor(d))) )
// .force('collision', d3.forceCollide().radius(7))
//     .force('center', forceCenter(centerX, centerY))
//    .on('tick', ticked);



      var simulation = forceSimulation(data)
        // .force('center', d3.forceCenter().x(width / 2).y(height / 2)) // Attraction to the center of the svg area
         .force("x",d3.forceX().strength(0.2).x(d => histXScale(histYAccessor(d))))
        .force('charge', d3.forceManyBody().strength(0.5)) // Nodes are attracted one each other of value is > 0
        .force('collide', d3.forceCollide().strength(.01).radius(30).iterations(1)) // Force that avoids circle overlapping
				.stop()
        .tick(140);
           
  
  let enterSelection = svg
  // this sets the circles to the center of the svg
   .attr("viewBox", [-10, -height / 2, width, height])
  .append('g')
  
      let circle = enterSelection.selectAll('circle')
        .data(data)
        .join('circle')
        .transition().duration(0).delay(0)
        //.attr('fill', 'black')
        .attr('fill', d => colorObj[colorAccessor(d)])
        .attr('stroke', '#000')
        .attr('r', d => d.Length * 3)
				// this uses the x/y attributes set on data by forceSimulation
        .attr('cx', (d, i) => d.x)
        .attr('cy', (d, i) => d.y);

}
